/*
  Licensed Materials - Property of IBM
  IBM WebSphere DataPower Appliances
  Copyright IBM Corporation 2014. All Rights Reserved.
  US Government Users Restricted Rights - Use, duplication or disclosure
  restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/*
  Determine the format of the inbound content
  Set up appropriate processing path
*/

var hm = require('header-metadata');
var service = require('service-metadata');

session.input.readAsJSON (function (readAsJSONError, jsonData) {
   if (readAsJSONError) {
          session.input.readAsBuffers(function (readAsBuffersError, data) {
        if (readAsBuffersError) {
            console.error('Error on readAsBuffers: ' + readAsBuffersError);
        } else {
          if (data.slice(0,5).toString() === '<?xml') {
 		   var rulename = "myxmlrule";
              session.INPUT.setVar('callrule', rulename);
		   console.log('xml rulename: ' + rulename);
             hm.current.set("Content-type", "text/xml");
             service.routingUrl = 'http://127.0.0.1:8888/xml/charges';  
              } else {
              var rulename = "mynonxmlrule";
              session.INPUT.setVar('callrule', rulename);
              console.log('nonxml rulename: ' + rulename);
             hm.current.set("Content-type", "application/octet-stream");
             service.routingUrl = 'http://127.0.0.1:8888/csv/charges';  
           } //end xml test       
         } //end read as buffer error
	 }) //end read as buffer function 
   } else {  //read as json error
        var rulename = "myjsonrule";
        session.INPUT.setVar('callrule', rulename);
        console.log('json rulename: ' + rulename);
        hm.current.set("Content-type", "text/json");
        service.routingUrl = 'http://127.0.0.1:8888/json/charges';  
    } // end read as json error
});  //end read as json function 


